#include<iostream>
#include<cstdio>
#include<string>
#include<vector>
#include<fstream>
#include<queue>
#include<algorithm>
#include<ctime>

using namespace std;

struct point {

    int x,y,num;

    bool operator < (const point&p) const {

        return num<p.num;

    }

};

int n,m,mbr,l;
int a[64][64],b[64][64];
int dir[5][3]={{0,1},{1,0},{-1,0},{0,-1}};
vector<point>v,ans,kans;

void read() {

    int i,j;
    point e;
    string s;

    scanf("%d",&n);

    for(i=0;i<n;i++) {
        for(j=0;j<n;j++) {
            cin>>s;
            if(s[0]=='B') a[i][j]=-1;
            else if(s[0]>='1'&&s[0]<='9') {
                if(s.size()==2) {
                    a[i][j]=10*(s[0]-'0')+s[1]-'0';
                    e.x=i;
                    e.y=j;
                    e.num=10*(s[0]-'0')+s[1]-'0';
                    v.push_back(e);
                }
                else {
                    a[i][j]=s[0]-'0';
                    e.x=i;
                    e.y=j;
                    e.num=s[0]-'0';
                    v.push_back(e);
                }
            }
        }
    }

}

void Print_Solution(vector<point>ans) {

    printf("%d\n",ans.size());

    for(int i=0;i<ans.size();i++) {
        printf("%d %d\n",ans[i].x,ans[i].y);
    }

}

void Solution_max(vector<point>ans,int br) {

    if((m-br)%2==0&&br>mbr) {
        int i,sz=ans.size();
        kans.clear();

        mbr=br;
        for(i=0;i<sz;i++) {
            kans.push_back(ans[i]);
        }

    }

}

bool check_in(int x,int y) {

    if(x>=0&&x<n&&y>=0&&y<n) return 1;
    return 0;

}

bool check_ans(int x,int y,vector<point>ans) {

    int xx,yy;
    int i,j,sz=ans.size();

    for(i=0;i<n;i++) {
        xx=x+dir[i][0];
        yy=y+dir[i][1];

        for(j=0;j<sz;j++) {
            if(ans[j].x==xx&&ans[j].y==yy) return 0;
        }

    }

    return 1;

}

void find_paths(point e,vector<point>ans,int br) {

    int i,xx,yy;
    point tc;

    for(i=0;i<4;i++) {
        xx=e.x+dir[i][0];
        yy=e.y+dir[i][1];

        if(a[xx][yy]>=1&&a[xx][yy]<=25) {
            if(check_ans(xx,yy,ans)) br++;
        }
    }

    ans.push_back(e);

    if(b[e.x][e.y]==1) {
        Solution_max(ans,br);
        return;
    }


    for(i=0;i<4;i++) {
        tc.x=e.x+dir[i][0];
        tc.y=e.y+dir[i][1];

        if(b[tc.x][tc.y]+1==b[e.x][e.y]) {
            find_paths(tc,ans,br);
        }

    }

}

bool check_neighbor(int x,int y) {

    int i;

    for(i=0;i<4;i++) {
        if(a[x+dir[i][0]][y+dir[i][1]]==-1) return 0;
    }

    return 1;

}

bool find_solution(point e) {

    int i,j,l=0;
    queue<point>q;
    point t,tc;

    memset(b,0,sizeof(b));

    b[e.x][e.y]=1;
    q.push(e);

    while(!q.empty()) {
        t=q.front();
        q.pop();

        for(i=0;i<4;i++) {
            tc.x=t.x+dir[i][0];
            tc.y=t.y+dir[i][1];

            if(check_in(tc.x,tc.y)&&!a[tc.x][tc.y]&&!b[tc.x][tc.y]&&check_neighbor(tc.x,tc.y)) {
                b[tc.x][tc.y]=b[t.x][t.y]+1;

                if(b[tc.x][tc.y]==e.num) {
                    ans.clear();
                    find_paths(tc,ans,0);
                    if(kans.size()) l=1;
                }
                else if(b[tc.x][tc.y]<e.num) q.push(tc);
            }

        }

    }

    if(l) return 1;
    return 0;

}

void solve() {

    int i,sz=v.size();

    sort(v.begin(),v.end());

    for(i=sz-1;i>=0;i--) {
        if(check_neighbor(v[i].x,v[i].y)) {
            l=1;
            if(find_solution(v[i])) {
                return;
            }
        }
    }

}

void find_solution_1 (point e) {

    int i,br=1;
    queue<point>q;
    point t,tc;

    ans.push_back(e);
    b[e.x][e.y]=1;

    memset(b,0,sizeof(b));

    if(br==e.num) return;

    q.push(e);

    while(!q.empty()) {
        t=q.front();
        q.pop();

        for(i=0;i<4;i++) {
            tc.x=t.x+dir[i][0];
            tc.y=t.y+dir[i][1];

            if(!a[tc.x][tc.y]&&!b[tc.x][tc.y]&&check_in(tc.x,tc.y)&&check_neighbor(tc.x,tc.y)) {
                br++;
                b[tc.x][tc.y]=1;

                ans.push_back(tc);
                if(br==e.num) return;

                q.push(tc);
            }
        }
    }

}

void solve_1() {

    int i,sz=v.size();

    ans.clear();

    for(i=0;i<sz;i++) {
        if(check_neighbor(v[i].x,v[i].y)) {
            find_solution_1(v[i]);
            return;
        }
    }

}

void solve_2() {

    int i,sz=v.size();

    ans.clear();

    for(i=sz-1;i>=0;i--) {
        if(check_neighbor(v[i].x,v[i].y)) {
            find_solution_1(v[i]);
            return;
        }
    }

}

int main() {

    freopen ( "game.in", "r",  stdin );
    freopen ( "game.out", "w", stdout );

    read();

    m=v.size();

    if(n==30) {
        solve_2();
        Print_Solution(ans);
    }
    else {

        solve();

        if(!kans.size()&&l) {
            solve_1();
            Print_Solution(ans);
        }
        else Print_Solution(kans);

    }

    return 0;

}